searchNodes=[{"doc":"PrefixedAPIKey is a quick Elixir port of Seam's Javascript Prefixed API Key library. It creates and verifies simple, random authentication tokens that have two useful prefix parts.This version is a little different (it has a smaller set of functions and uses a slightly bigger character set) but appears to be compatible with the original.OverviewExample key:mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgGSeam-style API Keys have these benefits:Double clicking the api key usually selects the entire api keyThe alphabet is standard across languages (the original uses Base58, this uses a slightly larger alphanumeric ASCII set)They are shorter than hex and base32 api keysThey have prefixes allowing secret scanning by githubThey have a hashed component so the server doesn't need to store the api key (reducing attack surface)They have unhashed short tokens which can be mutually used by the server and key bearer/customer to identify the api keyThey default to roughly the same number of entropy bits as UUIDv4The FormatPrefixed API Keys look like this:mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgGComponents:mycompany ..._... BRTRKFsL ..._... 51FwqftsmMDHHbJAMEXXHCgG ^ ^ ^ Prefix Short Token Long TokenThe Prefix is used to identify the company or service creating the API Key. This is very helpful in secret scanning.The Short Token is stored by both the server and the key bearer/customer, it can be used to identify an API key in logs or displayed on a customer's dashboard. A token can be deny-listed by its short token.The Long Token is how we authenticate this key. The long token is never stored on the server, but a hash of it is stored on the server. When we receive an incoming request, we search our database for short_token and hash.Exampleiex&gt; {:ok, key} = PrefixedApiKey.generate(&quot;example&quot;) iex&gt; api_key = key.api_key iex&gt; {:ok, _key} = PrefixedApiKey.parse(api_key) iex&gt; PrefixedApiKey.verify?(&quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot;, &quot;d5264a8fef50459c35306c35396c446cf88f8755c06ff70c341eb3fbd606ca44&quot;) true","ref":"PrefixedApiKey.html","title":"PrefixedApiKey","type":"module"},{"doc":"Generates a new API key, using the specified prefixUse the prefix to identify keys for your application.Exampleiex&gt; PrefixedApiKey.generate(&quot;doormouse&quot;)","ref":"PrefixedApiKey.html#generate/1","title":"PrefixedApiKey.generate/1","type":"function"},{"doc":"Parses a prefixed API Key string into its component parts, and produces a hash of the long token.(You can also parse an already-parsed key)Example iex&gt; PrefixedApiKey.parse(&quot;mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgG&quot;) {:ok, %PrefixedApiKey{ prefix: &quot;mycompany&quot;, short_token: &quot;BRTRKFsL&quot;, long_token: &quot;51FwqftsmMDHHbJAMEXXHCgG&quot;, api_key: &quot;mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgG&quot;, hash: &quot;d70d981d87b449c107327c2a2afbf00d4b58070d6ba571aac35d7ea3e7c79f37&quot; }}","ref":"PrefixedApiKey.html#parse/1","title":"PrefixedApiKey.parse/1","type":"function"},{"doc":"Compares an Prefixed API Key string (or struct) to a hash and short token that you have previously stored, for verification of the key.Exampleiex&gt; PrefixedApiKey.verify?( ...&gt; &quot;mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgG&quot;, ...&gt; &quot;d70d981d87b449c107327c2a2afbf00d4b58070d6ba571aac35d7ea3e7c79f37&quot;, ...&gt; &quot;BRTRKFsL&quot;) true","ref":"PrefixedApiKey.html#verify?/2","title":"PrefixedApiKey.verify?/2","type":"function"},{"doc":"Compares an Prefixed API Key string (or struct) to a hash you have previously stored, for verification of the key.Exampleiex&gt; PrefixedApiKey.verify?( ...&gt; &quot;mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgG&quot;, ...&gt; &quot;d70d981d87b449c107327c2a2afbf00d4b58070d6ba571aac35d7ea3e7c79f37&quot;) true","ref":"PrefixedApiKey.html#verify?/3","title":"PrefixedApiKey.verify?/3","type":"function"},{"doc":"","ref":"PrefixedApiKey.html#t:t/0","title":"PrefixedApiKey.t/0","type":"type"},{"doc":"","ref":"PrefixedApiKey.LongToken.Bits.html","title":"PrefixedApiKey.LongToken.Bits","type":"module"},{"doc":"","ref":"PrefixedApiKey.LongToken.Bits.html#generate/0","title":"PrefixedApiKey.LongToken.Bits.generate/0","type":"function"},{"doc":"","ref":"PrefixedApiKey.LongToken.Bits.html#reset/0","title":"PrefixedApiKey.LongToken.Bits.reset/0","type":"function"},{"doc":"","ref":"PrefixedApiKey.LongToken.Encoding.html","title":"PrefixedApiKey.LongToken.Encoding","type":"module"},{"doc":"","ref":"PrefixedApiKey.LongToken.Encoding.html#encode/1","title":"PrefixedApiKey.LongToken.Encoding.encode/1","type":"function"},{"doc":"","ref":"PrefixedApiKey.ShortToken.Bits.html","title":"PrefixedApiKey.ShortToken.Bits","type":"module"},{"doc":"","ref":"PrefixedApiKey.ShortToken.Bits.html#generate/0","title":"PrefixedApiKey.ShortToken.Bits.generate/0","type":"function"},{"doc":"","ref":"PrefixedApiKey.ShortToken.Bits.html#reset/0","title":"PrefixedApiKey.ShortToken.Bits.reset/0","type":"function"},{"doc":"","ref":"PrefixedApiKey.ShortToken.Encoding.html","title":"PrefixedApiKey.ShortToken.Encoding","type":"module"},{"doc":"","ref":"PrefixedApiKey.ShortToken.Encoding.html#encode/1","title":"PrefixedApiKey.ShortToken.Encoding.encode/1","type":"function"},{"doc":"PrefixedAPIKeyPrefixedAPIKey is a quick Elixir port of Seam's Javascript Prefixed API Key library. It creates and verifies simple, random authentication tokens that have two useful prefix parts.This version is a little different (it has a smaller set of functions and uses a slightly bigger character set) but appears to be compatible with the original.","ref":"readme.html","title":"PrefixedAPIKey","type":"extras"},{"doc":"The package can be installed by adding prefixed_api_key to your list of dependencies in mix.exs:def deps do [ {:prefixed_api_key, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"PrefixedAPIKey - Installation","type":"extras"},{"doc":"Example key:mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgGSeam-style API Keys have these benefits:Double clicking the api key usually selects the entire api keyThe alphabet is standard across languages (the original uses Base58, this uses a slightly larger alphanumeric ASCII set)They are shorter than hex and base32 api keysThey have prefixes allowing secret scanning by githubThey have a hashed component so the server doesn't need to store the api key (reducing attack surface)They have unhashed short tokens which can be mutually used by the server and key bearer/customer to identify the api keyThey default to roughly the same number of entropy bits as UUIDv4","ref":"readme.html#overview","title":"PrefixedAPIKey - Overview","type":"extras"},{"doc":"Prefixed API Keys look like this:mycompany_BRTRKFsL_51FwqftsmMDHHbJAMEXXHCgGComponents:mycompany ..._... BRTRKFsL ..._... 51FwqftsmMDHHbJAMEXXHCgG ^ ^ ^ Prefix Short Token Long TokenThe Prefix is used to identify the company or service creating the API Key. This is very helpful in secret scanning.The Short Token is stored by both the server and the key bearer/customer, it can be used to identify an API key in logs or displayed on a customer's dashboard. A token can be deny-listed by its short token.The Long Token is how we authenticate this key. The long token is never stored on the server, but a hash of it is stored on the server. When we receive an incoming request, we search our database for short_token and hash.","ref":"readme.html#the-format","title":"PrefixedAPIKey - The Format","type":"extras"},{"doc":"{:ok, key} = PrefixedApiKey.generate(&quot;myapp&quot;) # =&gt; # {:ok, # %PrefixedApiKey{ # api_key: &quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot;, # hash: &quot;d5264a8fef50459c35306c35396c446cf88f8755c06ff70c341eb3fbd606ca44&quot;, # long_token: &quot;E34CUQSRtlmf0CMLsKFjMOf7&quot;, # prefix: &quot;myapp&quot;, # short_token: &quot;ZLXZ3PYn&quot; # }} key.api_key # =&gt; &quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot; {:ok, key} = PrefixedApiKey.parse(&quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot;) # =&gt; # {:ok, # %PrefixedApiKey{ # api_key: &quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot;, # hash: &quot;d5264a8fef50459c35306c35396c446cf88f8755c06ff70c341eb3fbd606ca44&quot;, # long_token: &quot;E34CUQSRtlmf0CMLsKFjMOf7&quot;, # prefix: &quot;myapp&quot;, # short_token: &quot;ZLXZ3PYn&quot; # }} PrefixedApiKey.verify?(&quot;myapp_ZLXZ3PYn_E34CUQSRtlmf0CMLsKFjMOf7&quot;, &quot;d5264a8fef50459c35306c35396c446cf88f8755c06ff70c341eb3fbd606ca44&quot;) # =&gt; true","ref":"readme.html#examples","title":"PrefixedAPIKey - Examples","type":"extras"},{"doc":"Full API documentation can be found at https://hexdocs.pm/prefixed_api_key.","ref":"readme.html#api-documentation","title":"PrefixedAPIKey - API Documentation","type":"extras"},{"doc":"You can request new features by creating an issue, or submit a pull request with your contribution.","ref":"readme.html#contributing","title":"PrefixedAPIKey - Contributing","type":"extras"},{"doc":"The original Prefixed API KeyDiscussion on the original library at Hacker Newssecure_compare function was borrowed from Plug Crypto","ref":"readme.html#references","title":"PrefixedAPIKey - References","type":"extras"},{"doc":"Copyright (c) 2022 Digital Identity Ltd, UKPrefixedAPIKey is MIT licensed.","ref":"readme.html#copyright-and-license","title":"PrefixedAPIKey - Copyright and License","type":"extras"}]